package com.kingdee.eas.custom.jiuzhoutong.shuiyou;

import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.jiuzhoutong.utils.SYUtils;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.web.handler.tax.taxUnit.TaxUnitListHandler;
import okhttp3.*;
import org.apache.log4j.Logger;
import org.jgroups.blocks.RequestHandler;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Date;
import java.util.Map;
import java.util.Properties;

public class TaxUnitListHandlerEx extends TaxUnitListHandler {
    private Properties propt = new Properties();
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.jiuzhoutong.shuiyou.TaxUnitListHandlerEx");

    /**
     * ҵע
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void businessAegistrationAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String id = request.getParameter("id");
        Context context = SHRContext.getInstance().getContext();
        try {
            this.propt.load(new FileInputStream(System.getProperty("EAS_HOME") + "/server/properties/sy/syConfig.properties"));
            SYUtils syUtils = new SYUtils(propt);
            Map<String, String> commonParameter = syUtils.getCommonParameter();//ȡ
            TaxUnitInfo taxUnitInfo = TaxUnitFactory.getLocalInstance(context).getTaxUnitInfo(new ObjectUuidPK(id));
            String name = taxUnitInfo.getName();//ҵ
            String taxNumber = taxUnitInfo.getTaxNumber();//˰
            String areaCode = taxUnitInfo.getAreaCode();//
            OkHttpClient client = new OkHttpClient();
            String ip = propt.getProperty("ip");
            String postBody = "{\"qymc\":\""+name+"\",\"nsrsbh\":\""+taxNumber+"\",\"areaid\":\""+areaCode+"\"}";
            //gateway/iit/declare/getCompanyRegisterInfo
            RequestBody body = RequestBody.create(MediaType.parse("application/json"), postBody);
            Request sYRequest = new Request.Builder()
                    .url(ip+"/gateway/iit/declare/getCompanyRegisterInfo")
                    .post(body).headers(Headers.of(commonParameter))
                    .build();
            Response sYResponse = client.newCall(sYRequest).execute();
            if (sYResponse.isSuccessful()) {
                String responseData = sYResponse.body().string();
                JSONObject jsonObject = JSONObject.parseObject(responseData);
                System.out.println("Response Data:" + responseData);
                String fbmba = jsonObject.getString("fbmba");

            } else {
                System.out.println("Error Code:" + sYResponse.code());
            }

        } catch (BOSException e) {
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            throw new RuntimeException(e);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

    }
}
